---
### Install filebeat & metricbeat ###
- name: Installation des paquets requis
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - filebeat
    - metricbeat

- name: Fix directory permission
  ansible.builtin.file:
    path: "{{ item }}"
    state: directory
    owner: "root"
    group: "root"
    recurse: yes
    mode: u=rwX,g=rX,o-rwx
  loop:
    - "/etc/filebeat"
    - "/var/log/filebeat"
    - "/etc/filebeat/certs"
    - "/etc/metricbeat"
    - "/var/log/metricbeat"
    - "/etc/metricbeat/certs"

### Conf filebeat ###
- name: Copy elastic CA
  ansible.builtin.copy:
    src: "/etc/elasticsearch/certs/elasticsearch-ca.pem"
    dest: "/etc/filebeat/certs/elasticsearch-ca.pem"
    owner: "root"
    group: "root"
    mode: 0644
    remote_src: yes

- name: Copy filebeat.yml
  copy:
    src: ../roles/elk/elasticsearch/master/files/filebeat.yml
    dest: /etc/filebeat/filebeat.yml
    owner: root
    group: root
    mode: "0600"

- name: Copy module elasticsearch.yml
  copy:
    src: ../roles/elk/elasticsearch/master/files/filebeat_modules.d/elasticsearch.yml
    dest: /etc/filebeat/modules.d/elasticsearch.yml
    owner: root
    group: root
    mode: "0644"

- name: Setup Elasticsearch module for Filebeat
  ansible.builtin.command: filebeat setup

### Conf metricbeat ###
- name: Copy elastic CA
  ansible.builtin.copy:
    src: "/etc/elasticsearch/certs/elasticsearch-ca.pem"
    dest: "/etc/metricbeat/certs/elasticsearch-ca.pem"
    owner: "root"
    group: "root"
    mode: 0644
    remote_src: yes

- name: Copy metricbeat.yml
  copy:
    src: ../roles/elk/elasticsearch/master/files/metricbeat.yml
    dest: /etc/metricbeat/metricbeat.yml
    owner: root
    group: root
    mode: "0600"

- name: Copy module elasticsearch.yml
  copy:
    src: ../roles/elk/elasticsearch/master/files/metricbeat_modules.d/elasticsearch.yml
    dest: /etc/metricbeat/modules.d/elasticsearch.yml
    owner: root
    group: root
    mode: "0644"

- name: Setup Elasticsearch module for Metricbeat
  ansible.builtin.command: metricbeat setup

### Enable & start filebeat & metricbeat ###
- name: Enable services at boot
  systemd:
    name: "{{ item }}"
    enabled: yes
  loop:
    - filebeat
    - metricbeat

- name: Start services
  service:
    name: "{{ item }}"
    state: started
    enabled: yes
  loop:
    - filebeat
    - metricbeat